<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelVendasDlvOpera  {

    protected $RelVendasDlvOperaService;
    protected $utilService;
    
    public function __construct(Services\RelVendasDlvOperaService $RelVendasDlvOperaService, Utilities\Util $utilService) {
        $this->RelVendasDlvOperaService = $RelVendasDlvOperaService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $conditions = $this->utilService->getParamsAsArray($request);
        $conditions = $this->buildParams($conditions);
        $result = $this->RelVendasDlvOperaService->find($conditions['CDFILIAL'], $conditions['NRORG'], $conditions['DTVENDAINI'], $conditions['DTVENDAFIN']);
        
        $response->addDataSet(new DataSet("vnd0160L_RelVendasDlvOpera", $result));
        
        return $response;
    }
    
    public function buildParams($conditions){
        $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DTVENDAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTVENDAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        return $conditions;
    }
    
}
