<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Factories;

class ConfigTelaInicialCardapioService {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function getNovoCodigo($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::getNovoCodigo, $params);
		return $query;
	}
	
	public function manipuladorOrdem($params){
		
		try{
			if ($params['COND'] == "delete"){
				$paramsExcluir = array(
		            ':ORDEMEXIBE' => $params['ORDEMEXIBE'],
		            ':NRORG' => $params['NRORG'],
		            ':CDFILIAL' => $params['CDFILIAL'],
		            ':CDLOJA' => $params['CDLOJA']
		        );
				$this->entityManager->getConnection()->executeQuery(self::setOrdemExcluir, $paramsExcluir);
			}
			if ($params['COND'] == "deactivate"){
				$paramsExcluir = array(
		            ':ORDEMEXIBE' => $params['ORDEMANT'],
		            ':NRORG' => $params['NRORG'],
		            ':CDFILIAL' => $params['CDFILIAL'],
		            ':CDLOJA' => $params['CDLOJA']
		        );
				$this->entityManager->getConnection()->executeQuery(self::setOrdemExcluir, $paramsExcluir);
			}
			else if ($params['COND'] == "insert"){
				$paramsInserir = array(
					':CDCONFTELA' => $params['CDCONFTELA'],
		            ':ORDEMEXIBE' => $params['ORDEMEXIBE'],
		            ':NRORG' => $params['NRORG'],
		            ':CDFILIAL' => $params['CDFILIAL'],
		            ':CDLOJA' => $params['CDLOJA']
		        );
				$this->entityManager->getConnection()->executeQuery(self::setOrdemInserir, $paramsInserir);
				$this->entityManager->getConnection()->executeQuery(self::setInativo, $paramsInserir);
			}
			else if ($params['COND'] == "dimPosic"){
				
				$paramsEditar = array(
					':CDCONFTELA' => $params['CDCONFTELA'],
		            ':ALVO' => $params['ORDEMEXIBE'],
		            ':ATUAL' => $params['ORDEMANT'],
		            ':NRORG' => $params['NRORG'],
		            ':CDFILIAL' => $params['CDFILIAL'],
		            ':CDLOJA' => $params['CDLOJA']
		        );
				$this->entityManager->getConnection()->executeQuery(self::dimPosic, $paramsEditar);
			}
			else if ($params['COND'] == "aumPosic"){
				$paramsEditar = array(
					':CDCONFTELA' => $params['CDCONFTELA'],
		            ':ALVO' => $params['ORDEMEXIBE'],
		            ':ATUAL' => $params['ORDEMANT'],
		            ':NRORG' => $params['NRORG'],
		            ':CDFILIAL' => $params['CDFILIAL'],
		            ':CDLOJA' => $params['CDLOJA']
		        );
				$this->entityManager->getConnection()->executeQuery(self::aumPosic, $paramsEditar);
				
			}
			
		} catch(Exception $e){
            throw $e;
        }
		
		
		
	}
	
	public function getOrdem($row){
		
		$params = array(
			':NRORG' => $row[0]['value'],
		    ':CDFILIAL' => $row[1]['value'],
		    ':CDLOJA' => $row[2]['value']
		);
		
		$query = $this->entityManager->getConnection()->fetchAll(self::getCodigos, $params);
		return $query;
	}
	
	
	const getCodigos = "SELECT C.ORDEMEXIBE FROM CONFTELAINICARD C JOIN FILIAL F ON C.CDFILIAL = F.CDFILIAL AND C.NRORG = F.NRORG JOIN LOJA L ON F.CDFILIAL = L.CDFILIAL AND C.CDLOJA = L.CDLOJA AND C.NRORG = L.NRORG WHERE (C.CDFILIAL = :CDFILIAL)  AND ((C.CDLOJA  = :CDLOJA) OR (:CDLOJA IS NULL)) AND (C.NRORG = :NRORG) AND C.ORDEMEXIBE IS NOT NULL ORDER BY C.ORDEMEXIBE ASC";
	
	const setInativo = "UPDATE CONFTELAINICARD SET ORDEMEXIBE = null, IDATIVO = 'N' WHERE ORDEMEXIBE > 9 AND NRORG = :NRORG AND CDLOJA = :CDLOJA AND CDFILIAL = :CDFILIAL";
	
	const getNovoCodigo = "SELECT 
    						(CASE WHEN MAX(CDCONFTELA)+1 IS NULL THEN 001 ELSE MAX(CDCONFTELA)+1 END) AS NEXT_CD, (CASE WHEN MAX(ORDEMEXIBE)+1 IS NULL THEN 1 ELSE MAX(ORDEMEXIBE)+1 END) AS NEXT_ORDEM 
						   FROM 
    						CONFTELAINICARD 
						   WHERE NRORG = :NRORG AND CDLOJA = :CDLOJA AND CDFILIAL = :CDFILIAL";
						   
	const dimPosic = "UPDATE CONFTELAINICARD SET ORDEMEXIBE = ORDEMEXIBE+1 WHERE ORDEMEXIBE >= :ALVO AND ORDEMEXIBE < :ATUAL AND NRORG = :NRORG AND CDLOJA = :CDLOJA AND CDFILIAL = :CDFILIAL AND CDCONFTELA <> :CDCONFTELA";
	const aumPosic = "UPDATE CONFTELAINICARD SET ORDEMEXIBE = ORDEMEXIBE-1 WHERE ORDEMEXIBE <= :ALVO AND ORDEMEXIBE > :ATUAL AND NRORG = :NRORG AND CDLOJA = :CDLOJA AND CDFILIAL = :CDFILIAL AND CDCONFTELA <> :CDCONFTELA";
					   
	const setOrdemInserir = "UPDATE CONFTELAINICARD SET ORDEMEXIBE = ORDEMEXIBE+1 WHERE ORDEMEXIBE >= :ORDEMEXIBE AND NRORG = :NRORG AND CDLOJA = :CDLOJA AND CDFILIAL = :CDFILIAL AND CDCONFTELA <> :CDCONFTELA";
	const setOrdemExcluir = "UPDATE CONFTELAINICARD SET ORDEMEXIBE = ORDEMEXIBE-1 WHERE ORDEMEXIBE > :ORDEMEXIBE AND NRORG = :NRORG AND CDLOJA = :CDLOJA AND CDFILIAL = :CDFILIAL";
	
	const atualizarOrdem = "UPDATE CONFTELAINICARD SET ORDEMEXIBE = :ALVO WHERE NRORG = :NRORG AND CDLOJA = :CDLOJA AND CDFILIAL = :CDFILIAL AND CDCONFTELA = :CDCONFTELA";
}
?>