<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use \Zeedhi\Framework\Util\Functions;

class RelInconsistenciasSincronizacaoPedidosService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function fetchReport($conditions){
	    if(Functions::arrayKeyExists('CDFILIAL', $conditions)){
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            $conditions['TCDFILIAL'] = NULL;
        } else {
            $conditions['CDFILIAL'] = NULL;
            $conditions['TCDFILIAL'] = 'T';
        }
        
	    $params = array(  
	        ':CDFILIAL'  => $conditions['CDFILIAL'],
            ':TCDFILIAL' => $conditions['TCDFILIAL'],
	        ':DTINI'     => $conditions['PERIODO'][0],   
	        ':DTFIN'     => $conditions['PERIODO'][1]
	    );
	    
	    return $this->entityManager->getConnection()->fetchAll(self::INCONSISTENCIAS_SINCRONIZACAO_PEDIDOS_QRY, $params);
	}
	
    const INCONSISTENCIAS_SINCRONIZACAO_PEDIDOS_QRY = "
        SELECT (F.CDFILIAL || '-' || F.NMFILIAL) AS LABELFILIAL, L.CDFILIAL, L.CDLOJA, L.NRVENDARESTAUX, L.DTHRABERMESA, L.DSLOG, L.DSLOGMSG 
            FROM LOGSINCDLV L
                INNER JOIN FILIAL F
                    ON F.CDFILIAL = L.CDFILIAL
                        AND F.IDATIVO = L.IDATIVO
            WHERE ((INSTR(:CDFILIAL, L.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                AND TO_DATE(L.DTHRABERMESA) BETWEEN :DTINI AND :DTFIN
        ORDER BY L.CDFILIAL, L.DTHRABERMESA
    ";
}