<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Factories\RelatoriosSaldoConsumidorFactory;

class RelatoriosSaldoConsumidorService {
    protected $RelatoriosSaldoConsumidorFactory;

    public function __construct(RelatoriosSaldoConsumidorFactory $RelatoriosSaldoConsumidorFactory) {
        $this->RelatoriosSaldoConsumidorFactory = $RelatoriosSaldoConsumidorFactory;
    }

    public function find($conditions) {
        $result = [];
        
        if($conditions['IDRELATORIO'] == 0) {
            // Relatório Validações RNF
            $result = $this->RelatoriosSaldoConsumidorFactory->findSaldoNegativoConsumidorAtual($conditions);
            
        } else if($conditions['IDRELATORIO'] == 1) {
            // Relatório Resumo de Notas Fiscais
            $result = $this->RelatoriosSaldoConsumidorFactory->findSaldoPositivoConsumidorAtual($conditions);
            
        } else if($conditions['IDRELATORIO'] == 2) {
            // Relatório Detalhamento de RNF
            $result = $this->RelatoriosSaldoConsumidorFactory->findSaldoConsumidorPeriodo($conditions);
            
        } else if($conditions['IDRELATORIO'] == 3) {
            // Relatório Validações Baseadas em RNF
            $result = $this->RelatoriosSaldoConsumidorFactory->findSaldoNegativoConsumidorPeriodo($conditions);
            
        } else if($conditions['IDRELATORIO'] == 4) {
            // Relatório Validações Baseadas em RNF
            $result = $this->RelatoriosSaldoConsumidorFactory->findSaldoPositivoConsumidorPeriodo($conditions);
        } else if($conditions['IDRELATORIO'] == 5) {
            // Relatório Detalhamento de RNF
            $result = $this->RelatoriosSaldoConsumidorFactory->findConsumidoresSemMov($conditions);
            
        } else if($conditions['IDRELATORIO'] == 6) {
            // Relatório Validações Baseadas em RNF
            $result = $this->gerarExtratoFamilia($conditions);
            
        } else if($conditions['IDRELATORIO'] == 7) {
            // Relatório Validações Baseadas em RNF
            $result = $this->RelatoriosSaldoConsumidorFactory->findEstornoPorConsumidor($conditions);
        }
        return $result;
    }
    
    private function gerarExtratoFamilia($conditions) {
        try {
            $i = 0;
            
            // roda query1
            $extFam = $this->RelatoriosSaldoConsumidorFactory->findExtratoFamiliaQry1($conditions);
            
            if(!empty($extFam)) {
                foreach($extFam as $relFil) {
                    // roda query 2 e 3
                    $resultQuery2 = $this->RelatoriosSaldoConsumidorFactory->findExtratoFamiliaQry2($relFil);
                    $resultQuery3 = $this->RelatoriosSaldoConsumidorFactory->findExtratoFamiliaQry3($relFil);

                    $extFam[$i]['VRMOVIVEND'] = $resultQuery3[0]['VRMOVIVEND'];
                    $extFam[$i]['NMFAMILISALD'] = $extFam[$i]['NMFAMILISALD'].' - Saldo Anterior: R$'.number_format($extFam[$i]['SALDANT'], 2, ',', '.');
                    if(!empty($resultQuery2)) {
                        $extFam[$i]['NMPRODUTO']    = $resultQuery2[0]['NMPRODUTO'];
                        $extFam[$i]['QTDE']         = $resultQuery2[0]['QTDE'];
                        $extFam[$i]['VRTOTAL']      = $resultQuery2[0]['VRTOTAL'];
                    } else {
                        $extFam[$i]['NMPRODUTO']    = ' - ';
                        $extFam[$i]['QTDE']         = ' - ';
                        $extFam[$i]['VRTOTAL']      = '0';
                    }
                    
                    $i++;
                }
            }
            return $extFam;
        } catch(\Exception $e) {
            throw $e;
        }
    }

}

